#include "descriptor/descriptor.h"


/** oggetti **/
ITEM scena;
ITEM stanza, pareteSx, pareteFondo, pavimento;
ITEM tavolo,comodino,pomellocomodino,pera,picc,arancia,arancia2,quadro;
ITEM mandolino,manico,viti,bucomandolino,corpo,pickup,corde;
ITEM coltello,lama;

/** materiali **/
ITEM legno,marrone,marronechiaro,oro,nero,grigio,frutta,manicocolt,lamacolt;

void initMaterials()
{
  legno = create_attribute("legno");
  set_color(legno,0.5,0.3,0.4,0,0);
  set_reflectivity(legno,0,0);


  marrone = create_attribute("marrone");
  set_color(marrone,0.25,0.1,0.1,0.0,0.5);

  oro = create_attribute("oro");
  set_color(oro,1.0,1.0,0.0,1.0,1.0);
  set_reflectivity(oro,1.0,1.0);

  nero = create_attribute("nero");
  set_color(nero,0,0,0,0.5,0.5);
  set_reflectivity(nero,0.24,2);

  grigio = create_attribute("grigio");
  set_color(grigio,0.1,0.1,0.1,1.0,0.5);
  set_reflectivity(grigio,0.5,0.5);

  marronechiaro = create_attribute("marronechiaro");
  set_color(marronechiaro,0.96,0.88,0.52,1.0,1.0);

  frutta= create_attribute ("frutta");
  set_reflectivity(frutta,0.2,0.2);

  manicocolt = create_attribute("manicocolt");
  set_color(manicocolt,0.96,0.88,0.52,0.4,0.4);
  set_reflectivity(manicocolt,0,0);

  lamacolt = create_attribute("lamacolt");
  set_color(lamacolt,0.9,0.9,0.9,1.0,1.0);
  set_reflectivity(lamacolt,1.0,1.0);
}

void initLights()
{
    set_background(0,0,0,TRUE);
    //set_ambient_light(3.843137e-01,3.882353e-01,6.000000e-01,1.0); //leggeremente azzurro
    //create_point_light(3, 0, 8, 8.352941e-01, 8.705882e-01, 1.000000e+00, 1, 0, "diffusa");
   
    set_ambient_light(1,1,1,1);
    create_point_light(-10,10,1,1,1,1,3.3,20, "light1");
    create_point_light(-16,5, 35,1, 1, 1, 2, 70, "light2");
}

int main() {

  initLights();
  initMaterials();


  //creazione stanza
  pavimento = read_nurbs("bottom.db");
  set_domain_texture(pavimento, legno, "textures/pavimento.hr", 0.9, 1, 0.9, 1, TRUE, 0.6, 0.6);
  pareteFondo = read_nurbs("back.db");
  set_domain_texture(pareteFondo, legno, "textures/muro.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);
  pareteSx = read_nurbs("sx.db");
  set_domain_texture(pareteSx, legno, "textures/muro.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);
  

  stanza = create_list(pavimento, "stanza");
  stanza = insert_in_list(stanza, pareteFondo);
  stanza = insert_in_list(stanza, pareteSx);
  set_scale(stanza, 2, 2, 2);
  scena = create_list(stanza,"scena");

  //tavolo

  tavolo = read_nurbs("tavolino.db");
  set_scale(tavolo,8,8,8);
  set_translate(tavolo,3.5,0,3.850);
  //set_domain_texture(tavolo,legno,"textures/legno.hr", 0, 1, 0, 1, 1, 0.6, 0.6);
  set_attribute(tavolo, marrone);
  scena = insert_in_list(scena, tavolo);

  //comodino
  comodino = read_obj("comodino.obj", "comodino");
  set_z_rotate(comodino,45,0);

  set_scale(comodino,2.5,2.5,2.5);
  set_translate(comodino,3.0,-2.5,7.55);
 
  set_domain_texture(comodino,legno,"textures/legno.hr", 0.3, 1, 0.3, 1, 1, 0.6, 0.6);
  pomellocomodino = read_nurbs("pomellocomodino.db");
  set_z_rotate_abs(pomellocomodino,45,0);
  set_scale(pomellocomodino,2.5,2.5,2.5);
  set_translate(pomellocomodino,3.0,-2.5,7.55);
  set_attribute(pomellocomodino, oro);
  comodino  =insert_in_list(comodino,pomellocomodino);
  scena = insert_in_list(scena, comodino);
  
  //mandolino
  mandolino = read_obj("manico.obj", "mandolino"); 
  set_domain_texture(mandolino,legno,"textures/mandolino.hr", 0.8, 1, 0.8, 1, 1, 0.6, 0.6);
  viti = read_obj ("viti.obj", "viti");
  set_attribute(viti,grigio);
  mandolino = insert_in_list(mandolino, viti);
  bucomandolino = read_nurbs("bucomandolino.db");
  set_attribute(bucomandolino,marronechiaro);
  mandolino = insert_in_list(mandolino, bucomandolino);
  corpo = read_nurbs("mandolinosurf.db");
  set_domain_texture(corpo,legno,"textures/mandolino.hr", 0.8, 1, 0.8, 1, 1, 0.6, 0.6);
  mandolino = insert_in_list(mandolino, corpo);
  pickup = read_obj ("pickup.obj", "pickup");
  set_attribute(pickup,marronechiaro);
  mandolino = insert_in_list(mandolino, pickup);
  corde = read_obj ("corde.obj", "corde");
  set_attribute(corde,nero);
  mandolino = insert_in_list(mandolino, corde);
 
  set_z_rotate(mandolino,79,0);
  set_x_rotate(mandolino,90,0);
  set_y_rotate(mandolino,90,0);
  set_scale(mandolino,7,7,7);
  set_translate(mandolino,3.0,-3.74,10.08);

  scena = insert_in_list(scena, mandolino);


  //pera

  pera = read_nurbs("perasurf.db");
  set_domain_texture(pera,frutta,"textures/pera.hr", 0, 1, 0, 0.2, 1, 0.6, 0.6);
  picc = read_nurbs("piccsurf.db");
  set_attribute(picc, marrone);
  pera = create_list (pera, "pera");
  pera = insert_in_list(pera,picc);
  set_scale(pera,2,2,2);
  set_translate(pera,1.5,0,7.40);
  
  scena = insert_in_list(scena,pera);

  //arancia

  arancia = read_nurbs("aranciasurf.db");
  set_x_rotate(arancia,179.05,0);
  arancia = create_list(arancia,"arancia");
  set_scale(arancia,35,35,55);
  set_translate(arancia,1,1,7.875);
  set_domain_texture(arancia,frutta,"textures/arancia.hr", 0, 1, 0, 0.2, 1, 0.6, 0.6);

  arancia2 = read_nurbs ("aranciasurf.db");
  set_scale(arancia2,35,35,35);
  set_translate(arancia2,4,2.5,7.45);
  set_domain_texture(arancia2,frutta,"textures/arancia.hr", 0, 1, 0, 0.2, 1, 0.6, 0.6);
  arancia= insert_in_list(arancia,arancia2);
 
  scena = insert_in_list(scena,arancia);
  

  //quadro

  quadro = read_nurbs("quadrosurf.db");
 
 // arancia = create_list(arancia,"arancia");
 // set_scale(arancia,35,35,65);

   set_scale(quadro,1.3,1,1);
   set_domain_texture(quadro,legno,"textures/botero.hr", 0, 1, 0, 1, 1, 0.6, 0.6);
   set_z_rotate(quadro,175.4,0);
   set_translate(quadro,1,3,7.455);
   quadro = create_list (quadro, "quadro");
   scena = insert_in_list(scena,quadro);

//coltello

  lama = read_nurbs("lamasurf.db");
  set_attribute(lama,lamacolt);
  coltello = read_nurbs("manicocolsurf.db");
  set_attribute(coltello,manicocolt);
  coltello = create_list (coltello,"coltello");
  coltello = insert_in_list(coltello,lama);	
  set_x_rotate(coltello,1.5,0);
  //set_y_rotate(coltello,-2.1,0);
  set_z_rotate(coltello,1.5,0);
  set_scale(coltello,0.8,0.8,0.8);
  set_translate(coltello,4,3.5,7.65);
 
  scena = insert_in_list(scena,coltello);
  
  
  

 // scrittura file md
  save_scene("botero.md","botero",scena);

  return 0;
}
